diff --git a/src/editor.c b/src/editor.c
index 3d60181..b708de9 100644
--- a/src/editor.c
+++ b/src/editor.c
@@ -1010,12 +1010,21 @@ static void insert_indent_after_line(GeanyEditor *editor, gint line)
 static void auto_close_chars(ScintillaObject *sci, gint pos, gchar c)
 {
 	const gchar *closing_char = NULL;
+	gint end_pos = -1;
 
-	if ((editor_prefs.autoclose_chars & GEANY_AC_PARENTHESIS) && c == '(')
+	if (utils_isbrace(c,0)) {
+		printf("opening a brace...");
+		end_pos = SSM(sci, SCI_BRACEMATCH, pos-1, 0);
+		printf("endpos = %d\n", end_pos);
+	}
+
+	if ((editor_prefs.autoclose_chars & GEANY_AC_PARENTHESIS)
+		&& (end_pos == -1) && (c == '('))
 	{
 		closing_char = ")";
 	}
-	else if ((editor_prefs.autoclose_chars & GEANY_AC_CBRACKET) && c == '{')
+	else if ((editor_prefs.autoclose_chars & GEANY_AC_CBRACKET)
+		&& (end_pos == -1) && (c == '{'))
 	{
 		closing_char = "}";
 	}
@@ -1023,7 +1032,8 @@ static void auto_close_chars(ScintillaObject *sci, gint pos, gchar c)
 	{
 		closing_char = "]";
 	}
-	else if ((editor_prefs.autoclose_chars & GEANY_AC_SQUOTE) && c == '\'')
+	else if ((editor_prefs.autoclose_chars & GEANY_AC_SQUOTE)
+		&& (end_pos == -1) && (c == '\''))
 	{
 		closing_char = "'";
 	}
@@ -4202,9 +4212,7 @@ void editor_apply_update_prefs(GeanyEditor *editor)
 
 	/* (dis)allow scrolling past end of document */
 	sci_set_scroll_stop_at_last_line(sci, editor_prefs.scroll_stop_at_last_line);
-
 	sci_assign_cmdkey(sci, SCK_HOME,
 		editor_prefs.smart_home_key ? SCI_VCHOMEWRAP : SCI_HOMEWRAP);
 	sci_assign_cmdkey(sci, SCK_END,  SCI_LINEENDWRAP);
 }
-
